]> git.pld-linux.org Git - packages/apache1.git/blobdiff - apache1.init
- add missing config reload for -defaultindex
[packages/apache1.git] / apache1.init
index 01eaf2cf324908b4d485f9e71568709ccfc3dbb2..ffa6e3dcf3f9c6d8dbd1e6560e7ceba0950821ef 100644 (file)
@@ -5,9 +5,9 @@
 # chkconfig:   345 85 15
 # description: Apache is a World Wide Web server.  It is used to serve \
 #              HTML files and CGI.
-# processname: httpd
-# pidfile:     /var/run/httpd.pid
-# config:      /etc/httpd/httpd.conf
+# processname: apache
+# pidfile:     /var/run/apache.pid
+# config:      /etc/apache/apache.conf
 
 
 # Source function library
@@ -22,8 +22,7 @@
 # Check that networking is up.
 if is_yes "${NETWORKING}"; then
        if [ ! -f /var/lock/subsys/network -a "$1" != stop -a "$1" != status ]; then
-               # nls "ERROR: Networking is down. %s can't be run." <service>
-               msg_network_down httpd
+               msg_network_down apache
                exit 1
        fi
 else
@@ -34,42 +33,132 @@ if is_no "${IPV6_NETWORKING}"; then
        HTTPD_OPTS="$HTTPD_OPTS -4"
 fi
 
+configtest() {
+       apache -t > /dev/null 2>&1
+}
+
+start() {
+       # Check if the service is already running?
+       if [ -x /usr/lib/apache1/lingerd ]; then
+               if [ ! -f /var/lock/subsys/lingerd ]; then
+                       msg_starting lingerd
+                       SERVICE_UMASK=002 daemon --user http /usr/lib/apache1/lingerd
+                       RETVAL=$?
+                       [ $RETVAL -eq 0 ] && touch /var/lock/subsys/lingerd
+               else
+                       msg_already_running lingerd
+               fi
+       fi
+       if [ ! -f /var/lock/subsys/apache ]; then
+               msg_starting apache
+               daemon apache $HTTPD_OPTS
+               RETVAL=$?
+               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/apache
+       else
+               msg_already_running apache
+       fi
+}
+
+stop() {
+       # Stop daemons.
+       if [ -f /var/lock/subsys/apache ]; then
+               msg_stopping apache
+               killproc apache
+               rm -f /var/lock/subsys/apache /var/run/apache.pid /var/run/apache.loc* >/dev/null 2>&1
+       else
+               msg_not_running apache
+       fi
+       if [ -x /usr/lib/apache1/lingerd ]; then
+               if [ -f /var/lock/subsys/lingerd ]; then
+                       msg_stopping lingerd
+                       /usr/lib/apache1/lingerd -k && ok || fail
+                       rm -f /var/lock/subsys/lingerd >/dev/null 2>&1
+               else
+                       msg_not_running lingerd
+               fi
+       fi
+}
+
 RETVAL=0
 # See how we were called.
 case "$1" in
   start)
-       # Check if the service is already running?
-       if [ ! -f /var/lock/subsys/httpd ]; then
-               msg_starting httpd
-               daemon httpd $HTTPD_OPTS
+       start
+       ;;
+  stop)
+       stop
+       ;;
+  status)
+       status apache
+       RETVAL=$?
+       /usr/sbin/apache -S
+       ;;
+  restart)
+       apache -t > /dev/null 2>&1
+       RETVAL=$?
+       if [ $RETVAL -eq 0 ]; then
+               stop
+               start
+       else
+               fail
+               echo "Configuration file syntax test failed."
+       fi
+
+       ;;
+  force-reload)
+       if [ -f /var/lock/subsys/apache ]; then
+               msg_reloading apache
+
+               configtest
                RETVAL=$?
-               [ $RETVAL -eq 0 ] && touch /var/lock/subsys/httpd
+               if [ $RETVAL -eq 0 ]; then
+                       killproc apache -HUP
+               else
+                       fail
+                       echo "Configuration file syntax test failed."
+               fi
        else
-               msg_already_running httpd
+               msg_not_running apache
+               RETVAL=7
        fi
        ;;
-  stop)
-       # Stop daemons.
-       if [ -f /var/lock/subsys/httpd ]; then
-               msg_stopping httpd
-               killproc httpd
-               rm -f /var/lock/subsys/httpd /var/run/httpd.pid /var/run/httpd.loc* >/dev/null 2>&1
+  reload|graceful)
+       if [ -f /var/lock/subsys/apache ]; then
+               msg_reloading apache
+
+               configtest
+               RETVAL=$?
+               if [ $RETVAL -eq 0 ]; then
+                       killproc apache -USR1
+               else
+                       fail
+                       echo >&2 "Configuration file syntax test failed."
+               fi
        else
-               msg_not_running httpd
+               msg_not_running apache
+               RETVAL=7
        fi
        ;;
-  status)
-       status httpd
-       RETVAL=$?
-       /usr/sbin/httpd -S
+  flush-logs)
+       if [ -f /var/lock/subsys/apache ]; then
+               msg_reloading apache
+
+               configtest
+               RETVAL=$?
+               if [ $RETVAL -eq 0 ]; then
+                       killproc apache -HUP
+                       RETVAL=$?
+               else
+                       fail
+                       echo >&2 "Configuration file syntax test failed."
+               fi
+       fi
        ;;
-  restart|force-reload)
-       $0 stop
-       $0 start
-       exit $?
+  configtest)
+       apache -t
        ;;
   *)
-       msg_usage "$0 {start|stop|restart|force-reload|status}"
+       msg_usage "$0 {start|stop|restart|reload|force-reload|graceful|configtest|status}"
        exit 3
        ;;
 esac
This page took 0.049502 seconds and 4 git commands to generate.